import { createApp } from 'vue/dist/vue.esm-bundler'
import { createStore } from 'vuex'
import App from './App.vue'
import router from './router/index.js'

const store = createStore({
    state () {
        return {
            Session: {
                Token: null,
                User: null
            },
            Budgets: [],
            CurrentBudget: null,
        }
    },
    mutations: {
        initializeStore(state) {
            if(localStorage.getItem("store")){
                this.replaceState(
                    Object.assign(state, JSON.parse(localStorage.getItem("store")))
                );
            }
        },
        getDashboard (state) {
            fetch("/api/v1/dashboard", {
                headers: {
                    'Authorization': 'Bearer ' + state.Token
                }
            })
                .then(x => x.json())
                .then(x => state.Budgets = x.Budgets)
                .then(x => console.log(state.Budgets));
        },
        setTitle (state, title) {
            document.title = "Budgeteer - " + title;
        },
        setToken(state, token) {
            state.Token = token;
        }
    }
})

store.subscribe((mutation, state) => {
    localStorage.setItem("store", JSON.stringify(state));
})

const app = createApp(App)
app.use(router)
app.use(store)
app.mount('#app')
